---
title: GamepadButton
slug: Web/API/GamepadButton
tags:
  - API
  - Gamepad API
  - Games
  - NeedsBetterSpecLink
  - NeedsMarkupWork
  - Reference
  - Référence(2)
---
<div>{{APIRef("Gamepad API")}}</div>

<p>The <strong><code>GamepadButton</code></strong> interface defines an individual button of a gamepad or other controller, allowing access to the current state of different types of buttons available on the control device.</p>

<p>A <code>GamepadButton</code> object is returned by querying any value of the array returned by the <code>buttons</code> property of the {{domxref("Gamepad")}} interface.</p>

<div class="note">
<p><strong>Note</strong>: This is the case in Firefox Gecko 28 and later; Chrome and earlier Firefox versions still return an array of double values when this property is accessed.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("GamepadButton.value")}} {{readonlyInline}}</dt>
 <dd>A double value used to represent the current state of analog buttons, such as the triggers on many modern gamepads. The values are normalized to the range 0.0 —1.0, with 0.0 representing a button that is not pressed, and 1.0 representing a button that is fully pressed.</dd>
 <dt>{{domxref("GamepadButton.pressed")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("Boolean")}} value indicating whether the button is currently pressed (<code>true</code>) or unpressed (<code>false</code>).</dd>
</dl>

<h2 id="Example">Example</h2>

<p>The following code is taken from my Gamepad API button demo (you can <a href="https://chrisdavidmills.github.io/gamepad-buttons/">view the demo live</a>, and <a href="https://github.com/chrisdavidmills/gamepad-buttons/tree/master">find the source code</a> on Github.) Note the code fork — in Chrome {{domxref("Navigator.getGamepads")}} needs a <code>webkit</code> prefix and the button values are stored as an array of double values, whereas in Firefox {{domxref("Navigator.getGamepads")}} doesn't need a prefix, and the button values are stored as an array of {{domxref("GamepadButton")}} objects; it is the {{domxref("GamepadButton.value")}} or {{domxref("GamepadButton.pressed")}} properties of these we need to access, depending on what type of buttons they are. In this simple example I've just allowed either.</p>

<pre class="brush: js notranslate">function gameLoop() {
  if(navigator.webkitGetGamepads) {
    var gp = navigator.webkitGetGamepads()[0];

    if(gp.buttons[0] == 1) {
      b--;
    } else if(gp.buttons[1] == 1) {
      a++;
    } else if(gp.buttons[2] == 1) {
      b++;
    } else if(gp.buttons[3] == 1) {
      a--;
    }
  } else {
    var gp = navigator.getGamepads()[0];

    if(gp.buttons[0].value &gt; 0 || gp.buttons[0].pressed == true) {
      b--;
    } else if(gp.buttons[1].value &gt; 0 || gp.buttons[1].pressed == true) {
      a++;
    } else if(gp.buttons[2].value &gt; 0 || gp.buttons[2].pressed == true) {
      b++;
    } else if(gp.buttons[3].value &gt; 0 || gp.buttons[3].pressed == true) {
      a--;
    }
  }

  ball.style.left = a*2 + "px";
  ball.style.top = b*2 + "px";

  var start = rAF(gameLoop);
};</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Gamepad", "#gamepadbutton-interface", "GamepadButton")}}</td>
   <td>{{Spec2("Gamepad")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.GamepadButton")}}</p>

<h2 id="See_also">See also</h2>

<p><a href="/en-US/docs/Web/Guide/API/Gamepad">Using the Gamepad API</a></p>
